#include "JVM.h"

//     1        5 & 7
void JVM_ILOAD(JVM & myrefrence)
{
	short index = 0;
	*(char *)&index = myrefrence.whosnext(1);

	if(myrefrence.wide)
	{
		myrefrence.wide = 0;
		index <<= 8;
		*(char *)&index = myrefrence.whosnext(1);
	}

	myrefrence.pusher(4,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("ILOAD",&index,"from local variables + index + four bytes pushed on the stack.");
}

//     1        6 & 8
void JVM_LLOAD(JVM & myrefrence)
{
	short index = 0;
	*(char *)&index = myrefrence.whosnext(1);

	if(myrefrence.wide)
	{
		myrefrence.wide = 0;
		index <<= 8;
		*(char *)&index = myrefrence.whosnext(1);
	}

	myrefrence.pusher(8,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("LLOAD",&index,"from local variables + index + eight bytes pushed on the stack.");
}

//     1        9
void JVM_ALOAD(JVM & myrefrence)
{
	short index = 0;
	*(char *)&index = myrefrence.whosnext(1);

	if(myrefrence.wide)
	{
		myrefrence.wide = 0;
		index <<= 8;
		*(char *)&index = myrefrence.whosnext(1);
	}

	myrefrence.pusher(2,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("ALOAD",&index,"from local variables + index + two bytes pushed on the stack.");
}

//     1        A & 2        2
void JVM_ILOAD_0(JVM & myrefrence)
{
	myrefrence.pusher(4,(char *)(myrefrence.loadedfile) + 5000);

	myrefrence.messenger("ILOAD_0",NULL,"from local variables four bytes pushed on the stack.");
}

//     1        B & 2        3
void JVM_ILOAD_1(JVM & myrefrence)
{
	myrefrence.pusher(4,(char *)(myrefrence.loadedfile) + 5000 + 1);

	myrefrence.messenger("ILOAD_1",NULL,"from local variables + 1 four bytes pushed on the stack.");
}

//     1        C & 2        4
void JVM_ILOAD_2(JVM & myrefrence)
{
	myrefrence.pusher(4,(char *)(myrefrence.loadedfile) + 5000 + 2);

	myrefrence.messenger("ILOAD_2",NULL,"from local variables + 2 four bytes pushed on the stack.");
}

//     1        D & 2        5
void JVM_ILOAD_3(JVM & myrefrence)
{
	myrefrence.pusher(4,(char *)(myrefrence.loadedfile) + 5000 + 3);

	myrefrence.messenger("ILOAD_3",NULL,"from local variables + 3 four bytes pushed on the stack.");
}

//     1        E & 2        6
void JVM_LLOAD_0(JVM & myrefrence)
{
	myrefrence.pusher(8,(char *)(myrefrence.loadedfile) + 5000);

	myrefrence.messenger("LLOAD_0",NULL,"from local variables eight bytes pushed on the stack.");
}

//     1        F & 2        7
void JVM_LLOAD_1(JVM & myrefrence)
{
	myrefrence.pusher(8,(char *)(myrefrence.loadedfile) + 5000 + 1);

	myrefrence.messenger("LLOAD_1",NULL,"from local variables + 1 eight bytes pushed on the stack.");
}

//     2        0 & 2        8
void JVM_LLOAD_2(JVM & myrefrence)
{
	myrefrence.pusher(8,(char *)(myrefrence.loadedfile) + 5000 + 2);

	myrefrence.messenger("LLOAD_2",NULL,"from local variables + 2 eight bytes pushed on the stack.");
}

//     2        1 & 2        9
void JVM_LLOAD_3(JVM & myrefrence)
{
	myrefrence.pusher(8,(char *)(myrefrence.loadedfile) + 5000 + 3);

	myrefrence.messenger("LLOAD_3",NULL,"from local variables + 3 eight bytes pushed on the stack.");
}

//     2        A
void JVM_ALOAD_0(JVM & myrefrence)
{
	myrefrence.pusher(2,(char *)(myrefrence.loadedfile) + 5000);

	myrefrence.messenger("ALOAD_0",NULL,"from local variables two bytes pushed on the stack.");
}

//     2        B
void JVM_ALOAD_1(JVM & myrefrence)
{
	myrefrence.pusher(2,(char *)(myrefrence.loadedfile) + 5000 + 1);

	myrefrence.messenger("ALOAD_1",NULL,"from local variables + 1 two bytes pushed on the stack.");
}

//     2        C
void JVM_ALOAD_2(JVM & myrefrence)
{
	myrefrence.pusher(2,(char *)(myrefrence.loadedfile) + 5000 + 2);

	myrefrence.messenger("ALOAD_2",NULL,"from local variables + 2 two bytes pushed on the stack.");
}

//     2        D
void JVM_ALOAD_3(JVM & myrefrence)
{
	myrefrence.pusher(2,(char *)(myrefrence.loadedfile) + 5000 + 3);

	myrefrence.messenger("ALOAD_3",NULL,"from local variables + 3 two bytes pushed on the stack.");
}

//     2        E,3         0
void JVM_IALOAD(JVM & myrefrence)
{
	void * tmp = malloc(2);
	short index = 0,array_refrence = 0;
	myrefrence.poper(1,&index);
	myrefrence.poper(2,tmp);
	myrefrence.revbetw(2,tmp,&array_refrence);
	free(tmp);
	index += (unsigned int)array_refrence;

	myrefrence.pusher(4,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("IALOAD",NULL,"from address that earned from top of stack load four bytes on the top of stack.");
}

//     2        F,3         1
void JVM_LALOAD(JVM & myrefrence)
{
	void * tmp = malloc(2);
	short index = 0,array_refrence = 0;
	myrefrence.poper(1,&index);
	myrefrence.poper(2,tmp);
	myrefrence.revbetw(2,tmp,&array_refrence);
	free(tmp);
	index += (unsigned int)array_refrence;

	myrefrence.pusher(8,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("LALOAD",NULL,"from address that earned from top of stack load eight bytes on the top of stack.");
}

//     3        2 & 4 & 5
void JVM_AALOAD(JVM & myrefrence)
{
	void * tmp = malloc(2);
	short index = 0,array_refrence = 0;
	myrefrence.poper(1,&index);
	myrefrence.poper(2,tmp);
	myrefrence.revbetw(2,tmp,&array_refrence);
	free(tmp);
	index += (unsigned int)array_refrence;

	myrefrence.pusher(2,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("AALOAD",NULL,"from address that earned from top of stack load two bytes on the top of stack.");
}

//     3        3
void JVM_BALOAD(JVM & myrefrence)
{
	void * tmp = malloc(2);
	short index = 0,array_refrence = 0;
	myrefrence.poper(1,&index);
	myrefrence.poper(2,tmp);
	myrefrence.revbetw(2,tmp,&array_refrence);
	free(tmp);
	index += (unsigned int)array_refrence;

	myrefrence.pusher(1,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("BALOAD",NULL,"from address that earned from top of stack load one byte on the top of stack.");
}

//217 Lines