#include "JVM.h"

//     3        6 & 8
void JVM_ISTORE(JVM & myrefrence)
{
	short index = 0;
	*(char *)&index = myrefrence.whosnext(1);

	if(myrefrence.wide)
	{
		myrefrence.wide = 0;
		index <<= 8;
		*(char *)&index = myrefrence.whosnext(1);
	}

	myrefrence.poper(4,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("ISTORE",&index,"four bytes poped from the stack to local variables + index.");
}

//     3        7 & 9
void JVM_LSTORE(JVM & myrefrence)
{
	short index = 0;
	*(char *)&index = myrefrence.whosnext(1);

	if(myrefrence.wide)
	{
		myrefrence.wide = 0;
		index <<= 8;
		*(char *)&index = myrefrence.whosnext(1);
	}

	myrefrence.poper(8,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("LSTORE",&index,"eight bytes poped from the stack to local variables + index.");
}

//     3        A
void JVM_ASTORE(JVM & myrefrence)
{
	short index = 0;
	*(char *)&index = myrefrence.whosnext(1);

	if(myrefrence.wide)
	{
		myrefrence.wide = 0;
		index <<= 8;
		*(char *)&index = myrefrence.whosnext(1);
	}

	myrefrence.poper(2,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("ASTORE",&index,"two bytes poped from the stack to local variables + index.");
}

//     3        B & 4        3
void JVM_ISTORE_0(JVM & myrefrence)
{
	myrefrence.poper(4,(char *)(myrefrence.loadedfile) + 5000);

	myrefrence.messenger("ISTORE_0",NULL,"four bytes poped from the stack to local variables.");
}

//     3        C & 4        4
void JVM_ISTORE_1(JVM & myrefrence)
{
	myrefrence.poper(4,(char *)(myrefrence.loadedfile) + 5000 + 1);

	myrefrence.messenger("ISTORE_1",NULL,"four bytes poped from the stack to local variables + 1.");
}

//     3        D & 4        5
void JVM_ISTORE_2(JVM & myrefrence)
{
	myrefrence.poper(4,(char *)(myrefrence.loadedfile) + 5000 + 2);

	myrefrence.messenger("ISTORE_2",NULL,"four bytes poped from the stack to local variables + 2.");
}

//     3        E & 4        6
void JVM_ISTORE_3(JVM & myrefrence)
{
	myrefrence.poper(4,(char *)(myrefrence.loadedfile) + 5000 + 3);

	myrefrence.messenger("ISTORE_3",NULL,"four bytes poped from the stack to local variables + 3.");
}

//     3        F & 4        7
void JVM_LSTORE_0(JVM & myrefrence)
{
	myrefrence.poper(8,(char *)(myrefrence.loadedfile) + 5000);

	myrefrence.messenger("LSTORE_0",NULL,"eight bytes poped from the stack to local variables.");
}

//     4        0 & 4        8
void JVM_LSTORE_1(JVM & myrefrence)
{
	myrefrence.poper(8,(char *)(myrefrence.loadedfile) + 5000 + 1);

	myrefrence.messenger("LSTORE_1",NULL,"eight bytes poped from the stack to local variables + 1.");
}

//     4        1 & 4        9
void JVM_LSTORE_2(JVM & myrefrence)
{
	myrefrence.poper(8,(char *)(myrefrence.loadedfile) + 5000 + 2);

	myrefrence.messenger("LSTORE_2",NULL,"eight bytes poped from the stack to local variables + 2.");
}

//     4        2 & 4        A
void JVM_LSTORE_3(JVM & myrefrence)
{
	myrefrence.poper(8,(char *)(myrefrence.loadedfile) + 5000 + 3);

	myrefrence.messenger("LSTORE_3",NULL,"eight bytes poped from the stack to local variables + 3.");
}

//     4        B
void JVM_ASTORE_0(JVM & myrefrence)
{
	myrefrence.poper(2,(char *)(myrefrence.loadedfile) + 5000);

	myrefrence.messenger("ASTORE_0",NULL,"two bytes poped from the stack to local variables.");
}

//     4        C
void JVM_ASTORE_1(JVM & myrefrence)
{
	myrefrence.poper(2,(char *)(myrefrence.loadedfile) + 5000 + 1);

	myrefrence.messenger("ASTORE_1",NULL,"two bytes poped from the stack to local variables + 1.");
}

//     4        D
void JVM_ASTORE_2(JVM & myrefrence)
{
	myrefrence.poper(2,(char *)(myrefrence.loadedfile) + 5000 + 2);

	myrefrence.messenger("ASTORE_2",NULL,"two bytes poped from the stack to local variables + 2.");
}

//     4        E
void JVM_ASTORE_3(JVM & myrefrence)
{
	myrefrence.poper(2,(char *)(myrefrence.loadedfile) + 5000 + 3);

	myrefrence.messenger("ASTORE_3",NULL,"two bytes poped from the stack to local variables + 3.");
}

//     4        F,5         1
void JVM_IASTORE(JVM & myrefrence)
{
	void * tmp = malloc(4);
	void * tmp1 = malloc(2);
	short index = 0,array_refrence = 0;
	myrefrence.poper(4,tmp);
	myrefrence.poper(1,&index);
	myrefrence.poper(2,tmp);
	myrefrence.revbetw(2,tmp,&array_refrence);
	free(tmp1);
	index += (unsigned int)array_refrence;

	myrefrence.between(4,tmp,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);
	free(tmp);

	myrefrence.messenger("IASTORE",NULL,"store four bytes from the top of stack to address that earned from the top of stack.");
}

//     5        0,5         2
void JVM_LASTORE(JVM & myrefrence)
{
	void * tmp = malloc(8);
	void * tmp1 = malloc(2);
	short index = 0,array_refrence = 0;
	myrefrence.poper(8,tmp);
	myrefrence.poper(1,&index);
	myrefrence.poper(2,tmp);
	myrefrence.revbetw(2,tmp,&array_refrence);
	free(tmp1);
	index += (unsigned int)array_refrence;

	myrefrence.between(8,tmp,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);
	free(tmp);

	myrefrence.messenger("LASTORE",NULL,"store eight bytes from the top of stack to address that earned from the top of stack.");
}

//     5        3 & 5 & 6
void JVM_AASTORE(JVM & myrefrence)
{
	void * tmp = malloc(2);
	void * tmp1 = malloc(2);
	short index = 0,array_refrence = 0;
	myrefrence.poper(2,tmp);
	myrefrence.poper(1,&index);
	myrefrence.poper(2,tmp);
	myrefrence.revbetw(2,tmp,&array_refrence);
	free(tmp1);
	index += (unsigned int)array_refrence;

	myrefrence.between(2,tmp,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);
	free(tmp);
	
	myrefrence.messenger("AASTORE",NULL,"store two bytes from the top of stack to address that earned from the top of stack.");
}

//     5        4
void JVM_BASTORE(JVM & myrefrence)
{
	void * tmp = malloc(1);
	void * tmp1 = malloc(2);
	short index = 0,array_refrence = 0;
	myrefrence.poper(1,tmp);
	myrefrence.poper(1,&index);
	myrefrence.poper(2,tmp);
	myrefrence.revbetw(2,tmp,&array_refrence);
	free(tmp1);
	index += (unsigned int)array_refrence;

	myrefrence.between(1,tmp,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);
	free(tmp);

	myrefrence.messenger("BASTORE",NULL,"store one byte from the top of stack to address that earned from the top of stack.");
}

//229 Lines