#include "JVM.h"

void longnegative(long * tmp)
{
	if(*tmp == 0)
		*(tmp + 1) = - *(tmp + 1);
	else
	{
		*tmp = - *tmp;
		*(tmp + 1) = ~*(tmp + 1);
	}
}

void longadd(long * tmp1,long * tmp2)
{
	long double store;

	store = *tmp1;
	*tmp1 += *tmp2;
	store += *tmp2;
	store /= 65536;
	store /= 65536;

	*(tmp1 + 1) += *(tmp2 + 1);

	if(store != 0)
		*(tmp1 + 1) += 1;
}

void longsub(long * tmp1,long * tmp2)
{
	long double tmp3,tmp4;
	long tmp6;

	JVM::between(4,(char *)tmp1 + 4,&tmp6);
	tmp4 = (unsigned long)tmp6;
	tmp4 *= 65536;//= 4294967296;
	tmp4 *= 65536;//= 4294967296;
	JVM::between(4,tmp1,&tmp6);
	tmp4 += (unsigned long)tmp6;

	JVM::between(4,(char *)tmp2 + 4,&tmp6);
	tmp3 = (unsigned long)tmp6;
	tmp3 *= 65536;//= 4294967296;
	tmp3 *= 65536;//= 4294967296;
	JVM::between(4,tmp2,&tmp6);
	tmp3 += (unsigned long)tmp6;

	tmp3 -= tmp4;

	*tmp1 = tmp3;
	tmp3 /= 65536;//= 4294967296;;
	tmp3 /= 65536;//= 4294967296;;
	*(tmp1 + 1) = tmp3;
}

//     6        0
void JVM_IADD(JVM & myrefrence)
{
	long tmp1 = 0,tmp2 = 0;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 += tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("IADD",NULL,"Add two integers from top of the stack and send result to the top of stack.");
}

//     6        1
void JVM_LADD(JVM & myrefrence)
{
	long * tmp1 = (long *) malloc(8);
	long * tmp2 = (long *) malloc(8);
	void * tmp = malloc(8);
	char sign1 = 0x80,sign2 = 0x80;
	
	myrefrence.poper(8,tmp);
	sign1 &= *(char *)tmp;
	myrefrence.revbetw(8,tmp,tmp1);

	if(sign1)
		longnegative(tmp1);

	myrefrence.poper(8,tmp);
	sign2 &= *(char *)tmp;
	myrefrence.revbetw(8,tmp,tmp2);

	if(sign2)
		longnegative(tmp2);

	sign1 ^= sign2;

	if(sign1)
	{
		longsub(tmp1,tmp2);

		if(!sign2)
			longnegative(tmp1);
	}
	else
	{
		longadd(tmp1,tmp2);

		if(sign2)
			longnegative(tmp1);
	}

	myrefrence.revbetw(8,tmp1,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("LADD",NULL,"Add two long integers from top of the stack and send result to the top of stack.");

	free(tmp1);
	free(tmp2);
	free(tmp);
}

//     6        2
void JVM_FADD(JVM & myrefrence)
{
	float tmp1,tmp2;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 += tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("FADD",NULL,"Add two floats from top of the stack and send result to the top of stack.");
}

//     6        3
void JVM_DADD(JVM & myrefrence)
{
	double tmp1,tmp2;
	void * tmp = malloc(8);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp2);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp1);
	tmp1 += tmp2;
	myrefrence.revbetw(8,&tmp1,tmp);
	myrefrence.pusher(8,tmp);
	free(tmp);

	myrefrence.messenger("DADD",NULL,"Add two doubles from top of the stack and send result to the top of stack.");
}

//     6        4
void JVM_ISUB(JVM & myrefrence)
{
	long tmp1 = 0,tmp2 = 0;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 -= tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("ISUB",NULL,"Subtract two integers from top of the stack and send result to the top of stack.");
}

//     6        5
void JVM_LSUB(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long * tmp1 = (long *) malloc(8);
	long * tmp2 = (long *) malloc(8);
	char sign1 = 0x80,sign2 = 0x80;

	myrefrence.poper(8,tmp);
	sign1 &= *(char *)tmp;
	myrefrence.revbetw(8,tmp,tmp1);

	if(sign1)
		longnegative(tmp1);

	myrefrence.poper(8,tmp);
	sign2 &= *(char *)tmp;
	myrefrence.revbetw(8,tmp,tmp2);

	if(sign2)
		longnegative(tmp2);

	sign1 ^= sign2;

	if(sign1)
	{
		longadd(tmp1,tmp2);

		if(!sign2)
			longnegative(tmp1);
	}
	else
	{
		longsub(tmp1,tmp2);

		if(sign2)
			longnegative(tmp1);
	}

	myrefrence.revbetw(8,tmp1,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("LSUB",NULL,"Subtract two long integers from top of the stack and send result to the top of stack.");
	free(tmp);
	free(tmp1);
	free(tmp2);
}

//     6        6
void JVM_FSUB(JVM & myrefrence)
{
	float tmp1,tmp2;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 -= tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("FSUB",NULL,"Subtract two floats from top of the stack and send result to the top of stack.");
}

//     6        7
void JVM_DSUB(JVM & myrefrence)
{
	double tmp1,tmp2;
	void * tmp = malloc(8);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp2);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp1);
	tmp1 -= tmp2;
	myrefrence.revbetw(8,&tmp1,tmp);
	myrefrence.pusher(8,tmp);
	free(tmp);

	myrefrence.messenger("DSUB",NULL,"Subtract two doubles from top of the stack and send result to the top of stack.");
}

//     6        8
void JVM_IMUL(JVM & myrefrence)
{
	long tmp1 = 0,tmp2 = 0;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 *= tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("IMUL",NULL,"Multiply two integers from top of the stack and send result to the top of stack.");
}

//     6        9
void JVM_LMUL(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long * tmp1 = (long *)malloc(8);
	long * tmp2 = (long *)malloc(8);
	long * tmp3 = (long *)malloc(8);
	long double store,remain;
	char sign1 = 0x80,sign2 = 0x80;

	myrefrence.poper(8,tmp);
	sign1 &= *(char *)tmp;

	if(sign1)
		longnegative((long *)tmp);

	myrefrence.revbetw(8,tmp,tmp1);

	myrefrence.poper(8,tmp);
	sign2 &= *(char *)tmp;

	if(sign2)
		longnegative((long *)tmp);

	myrefrence.revbetw(8,tmp,tmp2);

	store = (unsigned long)*tmp1;
	store *= (unsigned long)*tmp2;
	*tmp3 = store;

	store /= 65536;//= 4294967296;
	store /= 65536;//= 4294967296;
	remain = (long)store;
	store = (unsigned long)*(tmp1 + 1);
	store *= (unsigned long)*tmp2;
	remain += store;
	store = (unsigned long)*tmp1;
	store *= (unsigned long)*(tmp2 + 1);
	remain += store;
	*(tmp3 + 1) = remain;

	sign1 ^= sign2;

	if(sign1)
		longnegative((long *)tmp3);

	myrefrence.revbetw(8,tmp3,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("LMUL",NULL,"Multiply two long integers from top of the stack and send result to the top of stack.");
	free(tmp);
	free(tmp1);
	free(tmp2);
	free(tmp3);
}

//     6        A
void JVM_FMUL(JVM & myrefrence)
{
	float tmp1,tmp2;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 *= tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("FMUL",NULL,"Multiply two floats from top of the stack and send result to the top of stack.");
}

//     6        B
void JVM_DMUL(JVM & myrefrence)
{
	double tmp1,tmp2;
	void * tmp = malloc(8);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp2);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp1);
	tmp1 *= tmp2;
	myrefrence.revbetw(8,&tmp1,tmp);
	myrefrence.pusher(8,tmp);
	free(tmp);

	myrefrence.messenger("DMUL",NULL,"Multiply two doubles from top of the stack and send result to the top of stack.");
}

//     6        C
void JVM_IDIV(JVM & myrefrence)
{
	long tmp1 = 0,tmp2 = 0;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 /= tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("IDIV",NULL,"Divide two integers from top of the stack and send result to the top of stack.");
}

//     6        D
void JVM_LDIV(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long * tmp5 = (long *)malloc(8);
	long tmp2;
	long double tmp3,tmp4;
	char sign1 = 0x80,sign2 = 0x80;

	myrefrence.poper(8,tmp5);
	sign1 &= *(char *)tmp5;

	if(sign1)
		longnegative((long *)tmp5);

	myrefrence.revbetw(8,tmp5,tmp);

	myrefrence.between(4,(char *)tmp + 4,&tmp2);
	tmp4 = (unsigned long)tmp2;
	myrefrence.between(4,tmp,&tmp2);
	tmp4 *= 65536;//= 4294967296;
	tmp4 *= 65536;//= 4294967296;
	tmp4 += (unsigned long)tmp2;

	myrefrence.poper(8,tmp5);
	sign2 &= *(char *)tmp;

	if(sign2)
		longnegative((long *)tmp);

	myrefrence.revbetw(8,tmp5,tmp);

	myrefrence.between(4,(char *)tmp + 4,&tmp2);
	tmp3 = (unsigned long)tmp2;
	myrefrence.between(4,tmp,&tmp2);
	tmp3 *= 65536;//= 4294967296;
	tmp3 *= 65536;//= 4294967296;
	tmp3 += (unsigned long)tmp2;

	tmp3 /= tmp4;

	*tmp5 = tmp3;
	tmp3 /= 65536;//= 4294967296;;
	tmp3 /= 65536;//= 4294967296;;
	*(tmp5 + 1) = tmp3;

	sign1 ^= sign2;

	if(sign1)
		longnegative((long *)tmp5);

	myrefrence.revbetw(8,tmp5,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("LDIV",NULL,"Divide two long integers from top of the stack and send result to the top of stack.");
	free(tmp);
	free(tmp5);
}

//     6        E
void JVM_FDIV(JVM & myrefrence)
{
	float tmp1,tmp2;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 /= tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("FDIV",NULL,"Divide two floats from top of the stack and send result to the top of stack.");
}

//     6        F
void JVM_DDIV(JVM & myrefrence)
{
	double tmp1,tmp2;
	void * tmp = malloc(8);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp2);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp1);
	tmp1 /= tmp2;
	myrefrence.revbetw(8,&tmp1,tmp);
	myrefrence.pusher(8,tmp);
	free(tmp);

	myrefrence.messenger("DDIV",NULL,"Divide two doubles from top of the stack and send result to the top of stack.");
}

//     7        0
void JVM_IREM(JVM & myrefrence)
{
	long tmp1 = 0,tmp2 = 0;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 %= tmp2;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("IREM",NULL,"Give us reminder of division of two integers from top of the stack and send result to the top of stack.");
}

//     7        1
void JVM_LREM(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long * tmp5 = (long *)malloc(8);
	long tmp2;
	long double tmp3,tmp4;
	char sign1 = 0x80,sign2 = 0x80;

	myrefrence.poper(8,tmp5);
	sign1 &= *(char *)tmp5;

	if(sign1)
		longnegative((long *)tmp5);

	myrefrence.revbetw(8,tmp5,tmp);

	myrefrence.between(4,(char *)tmp + 4,&tmp2);
	tmp4 = (unsigned long)tmp2;
	myrefrence.between(4,tmp,&tmp2);
	tmp4 *= 65536;//= 4294967296;
	tmp4 *= 65536;//= 4294967296;
	tmp4 += (unsigned long)tmp2;

	myrefrence.poper(8,tmp5);
	sign2 &= *(char *)tmp;

	if(sign2)
		longnegative((long *)tmp);

	myrefrence.revbetw(8,tmp5,tmp);

	myrefrence.between(4,(char *)tmp + 4,&tmp2);
	tmp3 = (unsigned long)tmp2;
	myrefrence.between(4,tmp,&tmp2);
	tmp3 *= 65536;//= 4294967296;
	tmp3 *= 65536;//= 4294967296;
	tmp3 += (unsigned long)tmp2;

	tmp3 = fmod(tmp3,tmp4);

	*tmp5 = tmp3;
	tmp3 /= 65536;//= 4294967296;;
	tmp3 /= 65536;//= 4294967296;;
	*(tmp5 + 1) = tmp3;

	sign1 ^= sign2;

	if(sign1)
		longnegative((long *)tmp5);

	myrefrence.revbetw(8,tmp5,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("LREM",NULL,"Give us reminder of division of two long integers from top of the stack and send result to the top of stack.");
	free(tmp);
	free(tmp5);
}

//     7        2
void JVM_FREM(JVM & myrefrence)
{
	float tmp1,tmp2;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 = fmod(tmp1,tmp2);
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);

	myrefrence.messenger("FREM",NULL,"Give us reminder of division of two floats from top of the stack and send result to the top of stack.");
}

//     7        3
void JVM_DREM(JVM & myrefrence)
{
	double tmp1,tmp2;
	void * tmp = malloc(8);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp2);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp1);
	tmp1 = fmod(tmp1,tmp2);
	myrefrence.revbetw(8,&tmp1,tmp);
	myrefrence.pusher(8,tmp);
	free(tmp);

	myrefrence.messenger("DREM",NULL,"Give us reminder of division of two doubles from top of the stack and send result to the top of stack.");
}

//     7        4
void JVM_INEG(JVM & myrefrence)
{
	long tmp1 = 0;
	void * tmp = malloc(4);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 = -tmp1;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);
	free(tmp);
	myrefrence.messenger("INEG",NULL,"Negative the integer of the top of the stack.");
}

//     7        5
void JVM_LNEG(JVM & myrefrence)
{
	long * tmp = (long *)malloc(8);
	void * tmp2 = malloc(8);
	myrefrence.poper(8,tmp2);
	myrefrence.revbetw(8,tmp2,tmp);
	longnegative(tmp);
	myrefrence.revbetw(8,tmp,tmp2);
	myrefrence.pusher(8,tmp2);

	myrefrence.messenger("LNEG",NULL,"Negative the long integer of the top of the stack.");
	free(tmp);
	free(tmp2);
}

//     7        6 & 7
void JVM_FNEG(JVM & myrefrence)
{
	void * tmp = malloc(1);

	myrefrence.poper(1,tmp);
	*(char *)tmp ^= 0x80;
	myrefrence.pusher(1,tmp);
	myrefrence.messenger("FNEG",NULL,"Negative the float or double of the top of the stack.");
	free(tmp);
}

//     7        8
void JVM_ISHL(JVM & myrefrence)
{
	short behzad = 0;
	void * tmp = malloc(4);
	long tmp1;

	myrefrence.poper(1,&behzad);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 <<= behzad;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);

	myrefrence.messenger("ISHL",NULL,"Shift the integer on the top of the stack left top of stack time.");
	free(tmp);
}

//     7        9
void JVM_LSHL(JVM & myrefrence)
{
	short behzad = 0;
	void * tmp = malloc(8);
	long * tmp1 = (long *)malloc(8);
	char flag = 0;

	myrefrence.poper(1,&behzad);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,tmp1);

	for(int count = 0;count < behzad;count++)
	{
		if(*((char *)tmp1 + 3) & 0x80)
			flag = 1;

		*tmp1 <<= 1;
		*(tmp1 + 1) <<= 1;
		*((char *)tmp1 + 4) |= flag;
	}

	myrefrence.revbetw(8,tmp1,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("LSHL",NULL,"Shift the long integer on the top of the stack left top of stack time.");
	free(tmp);
	free(tmp1);
}

//     7        A & C
void JVM_ISHR(JVM & myrefrence)
{
	short behzad = 0;
	void * tmp = malloc(4);
	long tmp1;

	myrefrence.poper(1,&behzad);
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp1);
	tmp1 >>= behzad;
	myrefrence.revbetw(4,&tmp1,tmp);
	myrefrence.pusher(4,tmp);

	myrefrence.messenger("ISHR",NULL,"Shift the integer on the top of the stack right top of stack time.");
	free(tmp);
}

//     7        B & D
void JVM_LSHR(JVM & myrefrence)
{
	short behzad = 0;
	void * tmp = malloc(8);
	long * tmp1 = (long *)malloc(8);
	char flag = 0;

	myrefrence.poper(1,&behzad);
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,tmp1);

	for(int count = 0;count < behzad;count++)
	{
		if(*((char *)tmp1 + 4) & 0x01)
			flag = 0x08;

		*tmp1 >>= 1;
		*(tmp1 + 1) >>= 1;
		*((char *)tmp1 + 3) |= flag;
	}

	myrefrence.revbetw(8,tmp1,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("LSHR",NULL,"Shift the long integer on the top of the stack right top of stack time.");
	free(tmp);
	free(tmp1);
}

//     7        E
void JVM_IAND(JVM & myrefrence)
{
	long tmp1 = 0,tmp2 = 0;
	myrefrence.poper(4,&tmp1);
	myrefrence.poper(4,&tmp2);
	tmp1 &= tmp2;
	myrefrence.pusher(4,&tmp1);

	myrefrence.messenger("IAND",NULL,"And two integers from top of the stack and send result to the top of stack.");
}

//     7        F
void JVM_LAND(JVM & myrefrence)
{
	long * tmp1 = (long *) malloc(8);
	long * tmp2 = (long *) malloc(8);
	myrefrence.poper(8,tmp1);
	myrefrence.poper(8,tmp2);
	*tmp1 &= *tmp2;
	*(tmp1 + 1) &= *(tmp2 + 1);
	myrefrence.pusher(8,tmp1);
	free(tmp1);
	free(tmp2);

	myrefrence.messenger("LAND",NULL,"And two long integers from top of the stack and send result to the top of stack.");
}

//     8        0
void JVM_IOR(JVM & myrefrence)
{
	long tmp1 = 0,tmp2 = 0;
	myrefrence.poper(4,&tmp1);
	myrefrence.poper(4,&tmp2);
	tmp1 |= tmp2;
	myrefrence.pusher(4,&tmp1);

	myrefrence.messenger("IOR",NULL,"Or two integers from top of the stack and send result to the top of stack.");
}

//     8        1
void JVM_LOR(JVM & myrefrence)
{
	long * tmp1 = (long *) malloc(8);
	long * tmp2 = (long *) malloc(8);
	myrefrence.poper(8,tmp1);
	myrefrence.poper(8,tmp2);
	*tmp1 |= *tmp2;
	*(tmp1 + 1) |= *(tmp2 + 1);
	myrefrence.pusher(8,tmp1);
	free(tmp1);
	free(tmp2);

	myrefrence.messenger("LOR",NULL,"Or two long integers from top of the stack and send result to the top of stack.");
}

//     8        2
void JVM_IXOR(JVM & myrefrence)
{
	long tmp1 = 0,tmp2 = 0;
	myrefrence.poper(4,&tmp1);
	myrefrence.poper(4,&tmp2);
	tmp1 ^= tmp2;
	myrefrence.pusher(4,&tmp1);

	myrefrence.messenger("XOR",NULL,"Xor two integers from top of the stack and send result to the top of stack.");
}

//     8        3
void JVM_LXOR(JVM & myrefrence)
{
	long * tmp1 = (long *) malloc(8);
	long * tmp2 = (long *) malloc(8);
	myrefrence.poper(8,tmp1);
	myrefrence.poper(8,tmp2);
	*tmp1 ^= *tmp2;
	*(tmp1 + 1) ^= *(tmp2 + 1);
	myrefrence.pusher(8,tmp1);
	free(tmp1);
	free(tmp2);

	myrefrence.messenger("XOR",NULL,"Xor two long integers from top of the stack and send result to the top of stack.");
}

//     8        4
void JVM_IINC(JVM & myrefrence)
{
	long myparameter;
	short index = 0;
	*(char *)&index = myrefrence.whosnext(1);

	if(myrefrence.wide)
	{
		index <<= 8;
		*(char *)&index = myrefrence.whosnext(1);
	}

	short myconst = myrefrence.whosnext(1);

	if(myrefrence.wide)
	{
		myrefrence.wide = 0;
		myconst <<= 8;
		*(char *)&myconst = myrefrence.whosnext(1);
	}

	myrefrence.revbetw(4,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index,&myparameter);

	myparameter += myconst;

	myrefrence.revbetw(4,&myparameter,(char *)(myrefrence.loadedfile) + 5000 + (unsigned int)index);

	myrefrence.messenger("IINC",NULL,"Go to local variables + index and add const to that int.");

	textcolor(9);
	gotoxy(43,1);
	cprintf(" <");

	if((unsigned short)index < 16)
		cprintf("0");

    cprintf("%X",index);

	if((unsigned short)myconst < 16)
		cprintf("0");

    cprintf("%X",myconst);
	cprintf(">");
}

//851 Lines