#include "JVM.h"

void longnegative(long * tmp);

//     8        5
void JVM_I2L(JVM & myrefrence)
{
	void * tmp = malloc(4);
	char push;
	
	myrefrence.poper(4,tmp);
	myrefrence.pusher(4,tmp);

	if(*(char *)tmp & 0x80)
		push = 0xff;
	else
		push = 0;

	for(int count = 0;count < 4;count++)
		myrefrence.pusher(1,&push);

	myrefrence.messenger("I2L",NULL,"Cast the element of the top of the stack from integer to long integer.");
	free(tmp);
}

//     8        6
void JVM_I2F(JVM & myrefrence)
{
	void * tmp = malloc(4);
	long tmp2;
	float tmp3;
	
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	tmp3 = tmp2;
	myrefrence.revbetw(4,&tmp3,tmp);
	myrefrence.pusher(4,tmp);

	myrefrence.messenger("I2F",NULL,"Cast the element of the top of the stack from integer to float.");
	free(tmp);
}

//     8        7
void JVM_I2D(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long tmp2;
	double tmp3;
	
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp2);
	tmp3 = tmp2;
	myrefrence.revbetw(8,&tmp3,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("I2D",NULL,"Cast the element of the top of the stack from integer to double.");
	free(tmp);
}

//     8        8
void JVM_L2I(JVM & myrefrence)
{
	void * tmp = malloc(8);
	
	myrefrence.poper(8,tmp);
	myrefrence.pusher(4,(char *)tmp + 4);

	myrefrence.messenger("L2I",NULL,"Cast the element of the top of the stack from long integer to integer.");
	free(tmp);
}
	
//     8        9
void JVM_L2F(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long * anotmp = (long *)malloc(8);
	long tmp2;
	float tmp3;
	char sign = 0x80;
	
	myrefrence.poper(8,tmp);
	sign &= *(char *)tmp;
	myrefrence.revbetw(4,tmp,anotmp);

	if(sign)
		longnegative(anotmp);

	myrefrence.between(4,anotmp + 1,&tmp2);
	tmp3 = tmp2;
	myrefrence.between(4,anotmp,&tmp2);
	tmp3 *= 65536;//= 4294967296;
	tmp3 *= 65536;//= 4294967296;
	tmp3 += (unsigned long)tmp2;

	if(sign)
		tmp3 = -tmp3;

	myrefrence.revbetw(4,&tmp3,tmp);
	myrefrence.pusher(4,tmp);

	myrefrence.messenger("L2F",NULL,"Cast the element of the top of the stack from long integer to float.");
	free(tmp);
}

//     8        A
void JVM_L2D(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long * anotmp = (long *)malloc(8);
	long tmp2;
	double tmp3;
	char sign = 0x80;
	
	myrefrence.poper(8,tmp);
	sign &= *(char *)tmp;
	myrefrence.revbetw(4,tmp,anotmp);

	if(sign)
		longnegative(anotmp);
	
	myrefrence.between(4,anotmp + 1,&tmp2);
	tmp3 = tmp2;
	myrefrence.between(4,anotmp,&tmp2);
	tmp3 *= 65536;//= 4294967296
	tmp3 *= 65536;//= 4294967296
	tmp3 += (unsigned long)tmp2;

	if(sign)
		tmp3 = -tmp3;

	myrefrence.revbetw(8,&tmp3,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("L2D",NULL,"Cast the element of the top of the stack from long integer to double.");
	free(tmp);
}

//     8        B
void JVM_F2I(JVM & myrefrence)
{
	void * tmp = malloc(4);
	long tmp2;
	float tmp3;
	
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp3);
	tmp2 = tmp3;
	myrefrence.revbetw(4,&tmp2,tmp);
	myrefrence.pusher(4,tmp);

	myrefrence.messenger("F2I",NULL,"Cast the element of the top of the stack from float to integer.");
	free(tmp);
}

//     8        C
void JVM_F2L(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long * tmp2 = (long *)malloc(2 * sizeof(long));
	float tmp3;
	char sign = 0x80;

	myrefrence.poper(4,tmp);
	sign &= *(char *)tmp;
	myrefrence.revbetw(4,tmp,&tmp3);

	if(sign)
		tmp3 = -tmp3;

	*tmp2 = tmp3;
	tmp3 /= 65536;//= 4294967296
	tmp3 /= 65536;//= 4294967296
	*(tmp2 + 1) = tmp3;

	if(sign)
		longnegative(tmp2);

	myrefrence.revbetw(8,tmp2,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("F2L",NULL,"Cast the element of the top of the stack from float to long integer.");
	free(tmp);
	free(tmp2);
}

//     8        B
void JVM_F2D(JVM & myrefrence)
{
	void * tmp = malloc(8);
	double tmp2;
	float tmp3;
	
	myrefrence.poper(4,tmp);
	myrefrence.revbetw(4,tmp,&tmp3);
	tmp2 = tmp3;
	myrefrence.revbetw(8,&tmp2,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("F2D",NULL,"Cast the element of the top of the stack from float to double.");
	free(tmp);
}

//     8        E
void JVM_D2I(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long tmp2;
	double tmp3;
	
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp3);
	tmp2 = tmp3;
	myrefrence.revbetw(4,&tmp2,tmp);
	myrefrence.pusher(4,tmp);

	myrefrence.messenger("D2I",NULL,"Cast the element of the top of the stack from double to integer.");
	free(tmp);
}

//     8        F
void JVM_D2L(JVM & myrefrence)
{
	void * tmp = malloc(8);
	long * tmp2 = (long *)malloc(8);
	double tmp3;
	char sign = 0x80;
	
	myrefrence.poper(8,tmp);
	sign &= *(char *)tmp;
	myrefrence.revbetw(8,tmp,&tmp3);

	if(sign)
		tmp3 = -tmp3;

	*tmp2 = tmp3;
	tmp3 /= 65536;//= 4294967296
	tmp3 /= 65536;//= 4294967296
	*(tmp2 + 1) = tmp3;

	if(sign)
		longnegative(tmp2);

	myrefrence.revbetw(8,tmp2,tmp);
	myrefrence.pusher(8,tmp);

	myrefrence.messenger("D2L",NULL,"Cast the element of the top of the stack from double to long integer.");
	free(tmp);
	free(tmp2);
}

//     9        0
void JVM_D2F(JVM & myrefrence)
{
	void * tmp = malloc(8);
	float tmp2;
	double tmp3;
	
	myrefrence.poper(8,tmp);
	myrefrence.revbetw(8,tmp,&tmp3);
	tmp2 = tmp3;
	myrefrence.revbetw(4,&tmp2,tmp);
	myrefrence.pusher(4,tmp);

	myrefrence.messenger("D2F",NULL,"Cast the element of the top of the stack from double to float.");
	free(tmp);
}

//     9        1
void JVM_I2B(JVM & myrefrence)
{
	void * tmp = malloc(4);
	
	myrefrence.poper(4,tmp);
	myrefrence.pusher(1,(char *)tmp + 3);

	myrefrence.messenger("I2B",NULL,"Cast the element of the top of the stack from integer to byte.");
	free(tmp);
}

//     9        2 & 3
void JVM_I2C(JVM & myrefrence)
{
	void * tmp = malloc(4);
	
	myrefrence.poper(4,tmp);
	myrefrence.pusher(2,(char *)tmp + 2);

	myrefrence.messenger("I2C",NULL,"Cast the element of the top of the stack from integer to char.");
	free(tmp);
}

//288 Lines